' This example program is a simple interpreter which runs a bytecode program that toggles P0.

CON

  base	= $E80

DAT
		orgh	$E80
'
'
' Get byte code, look up descriptor long, load code longs, execute code longs, repeat
'
		org

		setptra	bytebase

nextbyte	rdbytec	x,ptra++		'0..2	get next byte code

		shl	x,#2			'3	convert byte code to descriptor address
		add	x,descbase		'4

		rdlong	x,x			'6..2	get descriptor long

		movd	:reps,x			'3	descriptor[8..0] holds code longs minus 1

		shr	x,#7			'4	descriptor[23..7] is code offset
		setptrb	x			'5	point PTRB to code longs

:reps		reps	#1,#1			'6	ready for fast in-line code load
		setindb	#code			'7	point INDB to in-line code
		rdlongc	indb++,ptrb++		'0..2	load code longs in-line using cached read

		mov	indb++,jmpback		'	finish in-line code with jmp back
		shr	x,#24-7			'	descriptor[31..24] is arbitrary value

code		long	0[32]			'	dynamic in-line code, loops to nextbyte


bytebase	long	base + bytes<<2
descbase	long	base + descs<<2
jmpback		jmp	#nextbyte		'jmp back instruction
x		long	0			'variable


bytes		byte	0	'push 0
		byte	1	'notp (pop)
		byte	2,$03	'loop


descs		long	(base + code0<<2)<<7 + 0
		long	(base + code1<<2)<<7 + 1
		long	(base + code2<<2)<<7 + 1


code0		pusha	#0			'constant 0

code1		popa	x			'notp
		notp	x

code2		rdbytec	x,ptra			'branch backwards by an 8-bit offset
		subptra	x
